Attribute VB_Name = "Modul2"
 Option Explicit
 Function privatkundenZinsberechnung(immobilienpreisString As String, _
                                     eigenkapitalString As String, _
                                     tilgungString As String, _
                                     neubauverhaltenString As String)
 
 ' Programm berechnet die monatliche Belastung
 ' bei einzugebendem Kaufpreis und Eigenkapital
 ' Dateiname: privatkundenZinsberechnung
 ' Lsung mit Funktionen
 
     Dim eigenkapital As Double
     Dim immobilienpreis As Double
     Dim monatlicheBelastung As Double
     Dim tilgung As Double
     Dim fehler As Boolean
     Dim neubauVerhalten As Boolean
     Dim beruecksichtigterPreis As Double
     
     If Not ueberpruefe_alle_Benutzereingaben(immobilienpreisString, eigenkapitalString, tilgungString, neubauverhaltenString, _
        immobilienpreis, eigenkapital, tilgung, neubauVerhalten) Then Exit Function
        
     If neubauVerhalten Then
        beruecksichtigterPreis = immobilienpreis * 0.8
     Else
        beruecksichtigterPreis = immobilienpreis
     End If
     privatkundenZinsberechnung = monatliche_Belastung_berechnen(eigenkapital, immobilienpreis, _
                                   beruecksichtigterPreis, tilgung)
 End Function
 Private Function ueberpruefe_alle_Benutzereingaben(ByVal immobilienpreisString As String, _
                                            ByVal eigenkapitalString As String, _
                                            ByVal tilgungString As String, _
                                            ByVal neubauverhaltenString As String, _
                                            immobilienpreis As Double, _
                                            eigenkapital As Double, _
                                            tilgung As Double, _
                                            neubauVerhalten As Boolean) _
                                            As Boolean
         ueberpruefe_alle_Benutzereingaben = True
         
         If Not wandle_in_Double_um(immobilienpreisString, immobilienpreis) Then
             ueberpruefe_alle_Benutzereingaben = False
             MsgBox ("Der Immobilienpreis muss eine Zahl sein!")
             Exit Function
         End If
                 
         If Not wandle_in_Double_um(eigenkapitalString, eigenkapital) Then
             ueberpruefe_alle_Benutzereingaben = False
             MsgBox ("Das Eigenkapital muss eine Zahl sein!")
             Exit Function
         End If
         
         If Not wandle_in_Double_um(tilgungString, tilgung) Then
             ueberpruefe_alle_Benutzereingaben = False
             MsgBox ("Die Tilgung muss eine Zahl sein!")
             Exit Function
         End If
         
         Select Case neubauverhaltenString
             Case "Ja", "ja"
                 neubauVerhalten = True
             Case "Nein", "nein"
                 neubauVerhalten = False
             Case Else
                 MsgBox ("Neubauverhalten mu Ja/ja oder Nein/nein sein!")
                 ueberpruefe_alle_Benutzereingaben = False
                 Exit Function
         End Select
 End Function
 Private Function wandle_in_Double_um(ByVal eingabe As String, rueckgabe As Double) _
                     As Boolean
     wandle_in_Double_um = True
     If Not IsNumeric(eingabe) Then
         MsgBox ("Der von Ihnen eingegebene Wert mu eine Zahl sein! ")
         wandle_in_Double_um = False
         Exit Function
     End If
     rueckgabe = CDbl(eingabe)
 End Function
Private Function monatliche_Belastung_berechnen(ByVal eigenkapital As Double, _
                     ByVal immobilienpreis As Double, _
                     ByVal beruecksichtigterPreis As Double, _
                     ByVal tilgung As Double) _
                     As Double
                                             
     Dim jahresBelastungZins As Double
     Dim jahresBelastungTilgung As Double
     Dim aufzunehmenderBetrag As Double
     
     Const zinsgrenze1 As Double = 0.6
     Const zinsgrenze2 As Double = 0.8
     Const zinsgrenze3 As Double = 1
     
     Const zinsBisZinsgrenze1 As Double = 6.25
     Const zinsZwischenZinsgrenze1UndZinsgrenze2 As Double = 7
     Const zinsZwischenZinsgrenze2UndZinsgrenze3 As Double = 7.5
     Const zinsUeberZinsgrenze3 As Double = 8.5
             
     aufzunehmenderBetrag = immobilienpreis - eigenkapital
         Select Case aufzunehmenderBetrag
             Case Is <= beruecksichtigterPreis * 0.6
                 jahresBelastungZins = (aufzunehmenderBetrag / 100) * zinsBisZinsgrenze1
             Case Is <= beruecksichtigterPreis * 0.8
                 jahresBelastungZins = (beruecksichtigterPreis * zinsgrenze1 / 100) * zinsBisZinsgrenze1 + _
                    ((aufzunehmenderBetrag - beruecksichtigterPreis * zinsgrenze1) / 100) * zinsZwischenZinsgrenze1UndZinsgrenze2
             Case Is <= beruecksichtigterPreis
                 jahresBelastungZins = ((beruecksichtigterPreis * zinsgrenze1) / 100) * zinsBisZinsgrenze1 + _
                    ((beruecksichtigterPreis * (zinsgrenze2 - zinsgrenze1)) / 100) * zinsZwischenZinsgrenze1UndZinsgrenze2 + _
                    ((aufzunehmenderBetrag - beruecksichtigterPreis * zinsgrenze2) / 100) * zinsZwischenZinsgrenze2UndZinsgrenze3
             Case Else
                 jahresBelastungZins = ((beruecksichtigterPreis * zinsgrenze1) / 100) * zinsBisZinsgrenze1 + _
                    ((beruecksichtigterPreis * (zinsgrenze2 - zinsgrenze1)) / 100) * zinsZwischenZinsgrenze1UndZinsgrenze2 + _
                    ((beruecksichtigterPreis * (zinsgrenze3 - zinsgrenze2)) / 100) * zinsZwischenZinsgrenze2UndZinsgrenze3 + _
                    ((aufzunehmenderBetrag - beruecksichtigterPreis) * zinsgrenze3 / 100) * (zinsUeberZinsgrenze3 + tilgung)
                 
         End Select
        jahresBelastungTilgung = (aufzunehmenderBetrag * tilgung) / 100
        monatliche_Belastung_berechnen = (jahresBelastungZins + jahresBelastungTilgung) / 12
 End Function

